#include "plugin.h"
#include <shlwapi.h>
#include <commctrl.h>

#define IDM_OPENTEXT 45111	// l͓KBԂȂ悤ɂ@\~Ƃ
#define ID_TOOLBAR	106

BOOL OnInit();
void OnQuit();
void OnTrackChange();
void OnStatusChange();
void OnConfig();

FITTLE_PLUGIN_INFO fpi = {
	PDK_VER,
	OnInit,
	OnQuit,
	OnTrackChange,
	OnStatusChange,
	OnConfig,
	NULL,
	NULL
};

static WNDPROC hOldProc;

// TuNXEBhEvV[W
LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp){
	switch(msg){
		case WM_COMMAND:
			if(LOWORD(wp)==IDM_OPENTEXT){
				char *pszPath = (char *)SendMessage(fpi.hParent, WM_FITTLE, GET_PLAYING_PATH, 0);
				char szPath[MAX_PATH*2];
				lstrcpyn(szPath, pszPath, MAX_PATH*2);
				PathRenameExtension(szPath, ".txt");
				if(PathFileExists(szPath)){
					ShellExecute(fpi.hParent, "open", szPath, NULL, NULL, SW_SHOWNORMAL);
				}
				return 0;
			}
			break;
	}
	return CallWindowProc(hOldProc, hWnd, msg, wp, lp);
}

/* Gg|g */
BOOL WINAPI _DllMainCRTStartup(HANDLE hModule, DWORD dwFunction, LPVOID lpNot){
    return TRUE;
}

/* NɈxĂ΂܂ */
BOOL OnInit(){
	hOldProc = (WNDPROC)SetWindowLong(fpi.hParent, GWL_WNDPROC, (LONG)WndProc);
	HWND hToolbar = (HWND)SendMessage(fpi.hParent, WM_FITTLE, GET_CONTROL, ID_TOOLBAR);

	TBADDBITMAP tbab = {HINST_COMMCTRL, IDB_STD_SMALL_COLOR};
	SendMessage(hToolbar, TB_ADDBITMAP, 0, (LPARAM)&tbab);

	TBBUTTON tbb[2] = {
		{0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0L, 0},
		{9+STD_FILENEW, IDM_OPENTEXT, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0L, 0}
	};
	SendMessage(hToolbar, TB_ADDBUTTONS, 2, (LPARAM)&tbb);

	return TRUE;
}

/* IɈxĂ΂܂ */
void OnQuit(){
	return;
}

/* Ȃς鎞ɌĂ΂܂ */
void OnTrackChange(){
	return;
}

/* ĐԂς鎞ɌĂ΂܂ */
void OnStatusChange(){
	return;
}

/* ݒʂĂяo܂ij*/
void OnConfig(){
	return;
}

#ifdef __cplusplus
extern "C"
{
#endif
__declspec(dllexport) FITTLE_PLUGIN_INFO *GetPluginInfo(){
	return &fpi;
}
#ifdef __cplusplus
}
#endif